function [F,f,pvalue,onemore]=testhf(T,p,z,y,sig,N)

m=round((T/10)+p);

Pm=inv(z(1:m,:)'*z(1:m,:));
beta=Pm*z(1:m,:)'*y(1:m,:);

for i=m+1:T,	
	Dm1=1+z(i,:)*Pm*z(i,:)';
	Km1=Pm*z(i,:)'/Dm1;
	
	beta(:,i-m+1)=beta(:,i-m)+Km1*(y(i)-z(i,:)*beta(:,i-m));
	
	A=diag(Pm);

	resid=y(1:i-1)-z(1:i-1,:)*beta(:,i-m);
	sigma=std(resid);

	for j=1:p+1,
		t_ratio(j,i-m)=beta(j,i-m)/(sqrt(A(j))*sigma);	
	end	

	Pm=(eye(p+1)-Pm*(z(i,:)'*z(i,:))/Dm1)*Pm;
	
	a(i-m)=y(i)-z(i,:)*beta(:,i-m);
	e(i-m)=a(i-m)/sqrt(Dm1);
end

a=a';
e=e';

omega=inv(z(m+1:T,:)'*z(m+1:T,:))*z(m+1:T,:)'*e;
epsilon=e-z(m+1:T,:)*omega;

F=((sumsqr(e)-sumsqr(epsilon))/(p+1))/(sumsqr(epsilon)/(length(e)-p-1));

F=ones(N,1)*F;

f=finv(sig,p+1,length(e)-p-1);
f=f';
onemore=F>=f;
pvalue=1-fcdf(F,p+1,length(e)-p-1);